# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Helix**, the nomination platform of ElecLink_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/eleclink-helix/platform-api) 

    The version of the OpenAPI document: 0.0.131
    Contact: team.eleclink@eleclink.co.uk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from helix_platform_api_public_client.models.business_process_step_block import BusinessProcessStepBlock
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

BUSINESSPROCESSCONTENTBLOCK_ONE_OF_SCHEMAS = ["BusinessProcessForkBlock", "BusinessProcessStepBlock"]

class BusinessProcessContentBlock(BaseModel):
    """
    BusinessProcessContentBlock
    """
    # data type: BusinessProcessForkBlock
    oneof_schema_1_validator: Optional[BusinessProcessForkBlock] = None
    # data type: BusinessProcessStepBlock
    oneof_schema_2_validator: Optional[BusinessProcessStepBlock] = None
    actual_instance: Optional[Union[BusinessProcessForkBlock, BusinessProcessStepBlock]] = None
    one_of_schemas: Set[str] = { "BusinessProcessForkBlock", "BusinessProcessStepBlock" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = BusinessProcessContentBlock.model_construct()
        error_messages = []
        match = 0
        # validate data type: BusinessProcessForkBlock
        if not isinstance(v, BusinessProcessForkBlock):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BusinessProcessForkBlock`")
        else:
            match += 1
        # validate data type: BusinessProcessStepBlock
        if not isinstance(v, BusinessProcessStepBlock):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BusinessProcessStepBlock`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in BusinessProcessContentBlock with oneOf schemas: BusinessProcessForkBlock, BusinessProcessStepBlock. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in BusinessProcessContentBlock with oneOf schemas: BusinessProcessForkBlock, BusinessProcessStepBlock. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into BusinessProcessForkBlock
        try:
            instance.actual_instance = BusinessProcessForkBlock.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into BusinessProcessStepBlock
        try:
            instance.actual_instance = BusinessProcessStepBlock.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into BusinessProcessContentBlock with oneOf schemas: BusinessProcessForkBlock, BusinessProcessStepBlock. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into BusinessProcessContentBlock with oneOf schemas: BusinessProcessForkBlock, BusinessProcessStepBlock. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], BusinessProcessForkBlock, BusinessProcessStepBlock]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())

from helix_platform_api_public_client.models.business_process_fork_block import BusinessProcessForkBlock
# TODO: Rewrite to not use raise_errors
BusinessProcessContentBlock.model_rebuild(raise_errors=False)

