# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Helix**, the nomination platform of ElecLink_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/eleclink-helix/platform-api) 

    The version of the OpenAPI document: 0.0.131
    Contact: team.eleclink@eleclink.co.uk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from helix_platform_api_public_client.models.organisation_market_settings_fr_nomination_settings import OrganisationMarketSettingsFrNominationSettings
from helix_platform_api_public_client.models.organisation_market_settings_gb_nomination_settings import OrganisationMarketSettingsGbNominationSettings
from typing import Optional, Set
from typing_extensions import Self

class OrganisationMarketSettings(BaseModel):
    """
    OrganisationMarketSettings
    """ # noqa: E501
    eic_code: Annotated[str, Field(strict=True)] = Field(alias="eicCode")
    gb_nomination_settings: OrganisationMarketSettingsGbNominationSettings = Field(alias="gbNominationSettings")
    fr_nomination_settings: OrganisationMarketSettingsFrNominationSettings = Field(alias="frNominationSettings")
    __properties: ClassVar[List[str]] = ["eicCode", "gbNominationSettings", "frNominationSettings"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrganisationMarketSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of gb_nomination_settings
        if self.gb_nomination_settings:
            _dict['gbNominationSettings'] = self.gb_nomination_settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of fr_nomination_settings
        if self.fr_nomination_settings:
            _dict['frNominationSettings'] = self.fr_nomination_settings.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrganisationMarketSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "eicCode": obj.get("eicCode"),
            "gbNominationSettings": OrganisationMarketSettingsGbNominationSettings.from_dict(obj["gbNominationSettings"]) if obj.get("gbNominationSettings") is not None else None,
            "frNominationSettings": OrganisationMarketSettingsFrNominationSettings.from_dict(obj["frNominationSettings"]) if obj.get("frNominationSettings") is not None else None
        })
        return _obj


